//Marius Nicoli	O(N*Q) cu elminarea dublurilor la ambele siruri
#include <stdio.h>
#include <algorithm>

#define DIM 100010

using namespace std;

struct query {
	int q;
	int p;
	int v;
};

int A[DIM];
query B[DIM];
char S[DIM];
int N, Q, a, i, j, ok, r, s;


int cmp1 (const query &a, const query &b) {
	return a.v < b.v;
}

int cmp2 (const query &a, const query &b) {
	return a.p < b.p;
}


int main() {
	FILE *f = fopen("alune.in","r");
	FILE *g = fopen("alune.out","w");
	fscanf(f,"%d %d",&N, &Q);
	for (i=1;i<=N;i++)
		fscanf(f,"%d",&A[i]);
	for (i=1;i<=Q;i++) {
		fscanf(f,"%d",&B[i].q);
		B[i].p = i;
	}
	sort(A+1, A+N+1);
	
	a = 1;
	for (i=2;i<=N;i++)
		if(A[i] != A[a]) {
			A[++a] = A[i];
		}
		
	sort(B+1, B+Q+1, cmp1);
		
		
	for (i=1;i<=Q;i++) {
		if (i!=1 && B[i].q == B[i-1].q) {
			B[i].v = B[i-1].v;
			continue;
		}
		ok = 1;
		r = B[i].q%A[1];
		for (j=2;j<=a;j++)
			if(B[i].q%A[j] != r) {
				ok = 0;
				break;
			}
		B[i].v = ok;
	}

	sort(B+1, B+Q+1, cmp2);
		
	for (i=1;i<=Q;i++) {
		S[s++] = (B[i].v == 1 ? '1' : '0');

	}
	S[s] = 0;
	fprintf(g,"%s\n", S);

	fclose(g);
	fclose(f);
	return 0;
}