//O(N*2^N + Comb(N,K) * N)
// Se genereaza fiecare submultime. Se verifica daca are fix K inmultiri
// Se calculeaza raspunsul actual si se compara la final cu solutia

#include <cstdio>
#define inf 2000000000
#define MAXN 40

using namespace std;
int A[MAXN], power[MAXN];
int N,K;
int i,conf,numar,suma,aux,maxim,j,minim;

int main()
{
	freopen("optim.in","r",stdin);
	freopen("optim.out","w",stdout);
	
	scanf("%d %d",&N,&K);
	for (i = 1; i <= N; ++i)
		scanf("%d",&A[i]);
	
	for (i = 0; i <= N; ++i)
		power[i] = 1<<i;
	
	maxim = -2000000000;
	minim =  2000000000;
	--N;
	for (conf = 0; conf < power[N]; ++conf){
		
		numar = 0;
		for (j = 0; j < N; ++j)
			numar += (conf & power[j]) > 0;
		
		if (numar != K) continue;
		
		aux = A[1]; suma = 0;
		for (j = 0;  j < N; ++j)
			if (conf & power[j])
				aux = aux * A[j+2];
			else {
				suma += aux;
				aux = A[j+2];
			}
		suma += aux;
		
		if (suma > maxim)
			maxim = suma;
		if (suma < minim)
			minim = suma;
	}
	
	printf("%d %d\n",minim, maxim);
	
	return 0;
}