#include <stdio.h>
#include <string.h>

#define DIM 33

int Max = -2000000000, Min = 2000000000, N, K, i, j, sum, nr;

int X[DIM];
int V[DIM];

void sol() {
	int W[DIM];
	int Y[DIM];
	memcpy(W, V, sizeof(W));
	memcpy(Y, X, sizeof(Y));
	int n = N;
	int ok;
	do {
		ok = 1;
		for (i=1;i<n;i++) {
			if (Y[i] == 1) {
				W[i]*=W[i+1];
				for (j=i+1;j<n;j++)
					W[j] = W[j+1];
				for (j=i;j<n;j++)
					Y[j] = Y[j+1];
				n--;
				ok = 0;
			}
		}
	} while (!ok);
	sum = 0;
	for (i=1;i<=n;i++)
		sum += W[i];
	if (sum > Max)
		Max = sum;
	if (sum < Min)
		Min = sum;
}

void back(int k) {
	if (k == N) {
		if (nr != K) {
			return;
		}
		sol();
		return;
	}
	for (int i=0;i<=1;i++) {
		X[k] = i;
		if (nr + X[k] <= K) {
			nr += X[k];
			back(k+1);
			nr -= X[k];
		}
	}
}

int main() {
	FILE *f = fopen("optim.in","r");
	FILE *g = fopen("optim.out","w");
	fscanf(f,"%d %d",&N, &K);
	for (i = 1; i<=N; i++) {
		fscanf(f,"%d",&V[i]);
	}
	fclose(f);
	back(1);
	fprintf(g,"%d %d\n",Min, Max);
	fclose(g);
	return 0;
}