#include <stdio.h>
#define DIM 33

struct per {
	int start;
	int lung;
};

int V[DIM];
int X[DIM];
per S[DIM];
int SP[DIM];
int PP[DIM][DIM];
int N, K, k, i, Min = 2000000000, Max = -2000000000, s, j, Rez;

void sol() {
	int aux = Rez + PP[ S[s].start ][ S[s].lung + 1] - SP[ S[s].start + S[s].lung ] + SP[ S[s].start - 1 ];
	if (aux > Max)
		Max = aux;
	if (aux < Min)
		Min = aux;
}

void back(int k) {
	if (k == K+1) {
		sol();
		return;
	}
	for (int i = X[k-1]+1;i<N;i++) {
		X[k] = i;
		
		if (k == 1) {
			s = 1;
			S[s].lung = 1;
			S[s].start = i;
		} else if (X[k] == X[k-1]+1) {
			S[s].lung++;
		} else {
			
			Rez += PP[ S[s].start ][ S[s].lung + 1];
			Rez -= SP[ S[s].start + S[s].lung] - SP[ S[s].start - 1 ];
			
			S[++s].lung = 1;
			S[s].start = i;
		}
		
		back(k+1);
		
		if (k == 1) {
			s = 1;
			S[s].lung = 1;
			S[s].start = i;
		} else if (X[k] == X[k-1]+1) {
			S[s].lung--;
		} else {
			
			s--;
			
			Rez -= PP[ S[s].start ][ S[s].lung + 1];
			Rez += SP[ S[s].start + S[s].lung ] - SP[ S[s].start - 1 ];
			
		}
		
	}
}

int main() {
	FILE *f = fopen("optim.in","r");
	FILE *g = fopen("optim.out","w");
	fscanf(f,"%d %d",&N, &K);
	for (i=1;i<=N;i++) {
		fscanf(f,"%d",&V[i]);
		SP[i] = SP[i-1] + V[i];
	}
	Rez = SP[N];
	//PP[i][j] = produsul numerelor din secventa cate incepe pe pozitia i si are lungimea j
	for (i=1;i<=N;i++) {
		PP[i][1] = V[i];
		for (j=2;j<=K+1;j++) {
			if (i+j-1 > N)
				break;
			PP[i][j] = PP[i][j-1] * V[i+j-1];
		}
			
	}
	
	fclose(f);
	back(1);
	fprintf(g,"%d %d\n",Min, Max);
	fclose(g);
	return 0;
}
