//Comb(N,K) * N
//Se genereaza cu ajutorul backtracking-ului asezarea +/*. 
//Se calculeaza raspunsul actual si se verifica cu solutia

#include <cstdio>
#define inf 2000000000
#define MAXN 40

using namespace std;

int A[MAXN];
int suma, maxim, aux, j,minim;
int N,K;

inline void verif(int conf)
{
	aux = A[1]; suma = 0;
	for (j = 0;  j < N; ++j)
		if (conf & (1<<j))
			aux = aux * A[j+2];
		else {
			suma += aux;
			aux = A[j+2];
		}
	suma += aux;
	
	if (suma > maxim)
		maxim = suma;
	if (suma < minim)
		minim = suma;
}

void back(int lv, int k, int conf)
{
	if (lv == N){
		verif(conf);
		return;
	}
	if (k > 0)
		back(lv+1, k-1, conf + (1<<lv));
	if (N - lv - 1>= k)
		back(lv+1, k, conf);
	
}
int main()
{
	freopen("optim.in","r",stdin);
	freopen("optim.out","w",stdout);
	
	scanf("%d %d",&N,&K);
	for (j=1; j<=N; ++j)
		scanf("%d", &A[j]);
	
	maxim = -2000000000;
	minim =  2000000000;
	--N;
	back(0, K, 0);
	
	printf("%d %d\n",minim, maxim);
	
	return 0;
}